import{s as Qe,o as Oe,n as Ke}from"../chunks/scheduler.bdbef820.js";import{S as et,i as tt,g as i,s as l,r as c,A as at,h as o,f as a,c as n,j as Re,u as p,x as r,k as Ge,y as st,a as s,v as h,d as m,t as f,w as u}from"../chunks/index.c0aea24a.js";import{T as lt}from"../chunks/Tip.31005f7d.js";import{C as q}from"../chunks/CodeBlock.6ccca92e.js";import{H as Q,E as nt}from"../chunks/EditOnGithub.725ee0c1.js";function it(K){let d,_='If you want to reuse a dataset from scratch, try setting the <code>download_mode</code> parameter in <a href="/docs/datasets/main/en/package_reference/loading_methods#datasets.load_dataset">load_dataset()</a> instead.';return{c(){d=i("p"),d.innerHTML=_},l(g){d=o(g,"P",{"data-svelte-h":!0}),r(d)!=="svelte-1kc0hsm"&&(d.innerHTML=_)},m(g,V){s(g,d,V)},p:Ke,d(g){g&&a(d)}}}function ot(K){let d,_,g,V,w,ee,y,Ye=`When you download a dataset from Hugging Face, the data are stored locally on your computer.
Files from Hugging Face are stored as usual in the <code>huggingface_hub</code> cache, which is at <code>~/.cache/huggingface/hub</code> by default.
See the <a href="https://huggingface.co/docs/huggingface_hub/guides/manage-cache" rel="nofollow">Hub cache documentation</a> for more details and how to change its location.`,te,b,Fe="The Hub cache allows 🤗 Datasets to avoid re-downloading dataset files from Hugging Face every time you use them.",ae,v,Le='🤗 Datasets also has its own cache to store datasets converted in Arrow format (the format used by <a href="/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset">Dataset</a> objects).',se,T,Xe="This guide focuses on the 🤗 Datasets cache and will show you how to:",le,C,De="<li>Change the cache directory.</li> <li>Control how a dataset is loaded from the cache.</li> <li>Clean up cache files in the directory.</li> <li>Enable or disable caching.</li>",ne,M,ie,x,Ue="The default 🤗 Datasets cache directory is <code>~/.cache/huggingface/datasets</code>. Change the cache location by setting the shell environment variable, <code>HF_DATASETS_CACHE</code> to another directory:",oe,k,de,Z,We="When you load a dataset, you also have the option to change where the data is cached. Change the <code>cache_dir</code> parameter to the path you want:",re,J,ce,H,pe,j,Ee='After you download a dataset, control how it is loaded by <a href="/docs/datasets/main/en/package_reference/loading_methods#datasets.load_dataset">load_dataset()</a> with the <code>download_mode</code> parameter. By default, 🤗 Datasets will reuse a dataset if it exists. But if you need the original dataset without any processing functions applied, re-download the files as shown below:',he,R,me,G,Ie='Refer to <a href="/docs/datasets/main/en/package_reference/builder_classes#datasets.DownloadMode">DownloadMode</a> for a full list of download modes.',fe,Y,ue,F,ze='Clean up the Arrow cache files in the directory with <a href="/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.cleanup_cache_files">Dataset.cleanup_cache_files()</a>:',ge,L,$e,X,_e,D,Ne='If you’re using a cached file locally, it will automatically reload the dataset with any previous transforms you applied to the dataset. Disable this behavior by setting the argument <code>load_from_cache_file=False</code> in <a href="/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map">Dataset.map()</a>:',we,U,ye,W,Pe="In the example above, 🤗 Datasets will execute the function <code>add_prefix</code> over the entire dataset again instead of loading the dataset from its previous state.",be,E,Se='Disable caching on a global scale with <a href="/docs/datasets/main/en/package_reference/main_classes#datasets.disable_caching">disable_caching()</a>:',ve,I,Te,z,Ae="When you disable caching, 🤗 Datasets will no longer reload cached files when applying transforms to datasets. Any transform you apply on your dataset will be need to be reapplied.",Ce,$,Me,B,xe,N,ke,P,Ve="Disabling the cache and copying the dataset in-memory will speed up dataset operations. There are two options for copying the dataset in-memory:",Ze,S,Be="<li><p>Set <code>datasets.config.IN_MEMORY_MAX_SIZE</code> to a nonzero value (in bytes) that fits in your RAM memory.</p></li> <li><p>Set the environment variable <code>HF_DATASETS_IN_MEMORY_MAX_SIZE</code> to a nonzero value. Note that the first method takes higher precedence.</p></li>",Je,A,He,O,je;return w=new Q({props:{title:"Cache management",local:"cache-management",headingTag:"h1"}}),M=new Q({props:{title:"Cache directory",local:"cache-directory",headingTag:"h2"}}),k=new q({props:{code:"JTI0JTIwZXhwb3J0JTIwSEZfREFUQVNFVFNfQ0FDSEUlM0QlMjIlMkZwYXRoJTJGdG8lMkZhbm90aGVyJTJGZGlyZWN0b3J5JTJGZGF0YXNldHMlMjI=",highlighted:'$ <span class="hljs-built_in">export</span> <span class="hljs-attribute">HF_DATASETS_CACHE</span>=<span class="hljs-string">&quot;/path/to/another/directory/datasets&quot;</span>',wrap:!1}}),J=new q({props:{code:"ZnJvbSUyMGRhdGFzZXRzJTIwaW1wb3J0JTIwbG9hZF9kYXRhc2V0JTBBZGF0YXNldCUyMCUzRCUyMGxvYWRfZGF0YXNldCgndXNlcm5hbWUlMkZkYXRhc2V0JyUyQyUyMGNhY2hlX2RpciUzRCUyMiUyRnBhdGglMkZ0byUyRmFub3RoZXIlMkZkaXJlY3RvcnklMkZkYXRhc2V0cyUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&#x27;username/dataset&#x27;</span>, cache_dir=<span class="hljs-string">&quot;/path/to/another/directory/datasets&quot;</span>)`,wrap:!1}}),H=new Q({props:{title:"Download mode",local:"download-mode",headingTag:"h2"}}),R=new q({props:{code:"ZnJvbSUyMGRhdGFzZXRzJTIwaW1wb3J0JTIwbG9hZF9kYXRhc2V0JTBBZGF0YXNldCUyMCUzRCUyMGxvYWRfZGF0YXNldCgnc3F1YWQnJTJDJTIwZG93bmxvYWRfbW9kZSUzRCdmb3JjZV9yZWRvd25sb2FkJyk=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&#x27;squad&#x27;</span>, download_mode=<span class="hljs-string">&#x27;force_redownload&#x27;</span>)`,wrap:!1}}),Y=new Q({props:{title:"Cache files",local:"cache-files",headingTag:"h2"}}),L=new q({props:{code:"ZGF0YXNldC5jbGVhbnVwX2NhY2hlX2ZpbGVzKCk=",highlighted:`<span class="hljs-comment"># Returns the number of removed cache files</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset.cleanup_cache_files()
<span class="hljs-number">2</span>`,wrap:!1}}),X=new Q({props:{title:"Enable or disable caching",local:"enable-or-disable-caching",headingTag:"h2"}}),U=new q({props:{code:"dXBkYXRlZF9kYXRhc2V0JTIwJTNEJTIwc21hbGxfZGF0YXNldC5tYXAoYWRkX3ByZWZpeCUyQyUyMGxvYWRfZnJvbV9jYWNoZV9maWxlJTNERmFsc2Up",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>updated_dataset = small_dataset.<span class="hljs-built_in">map</span>(add_prefix, load_from_cache_file=<span class="hljs-literal">False</span>)',wrap:!1}}),I=new q({props:{code:"ZnJvbSUyMGRhdGFzZXRzJTIwaW1wb3J0JTIwZGlzYWJsZV9jYWNoaW5nJTBBZGlzYWJsZV9jYWNoaW5nKCk=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> disable_caching
<span class="hljs-meta">&gt;&gt;&gt; </span>disable_caching()`,wrap:!1}}),$=new lt({props:{$$slots:{default:[it]},$$scope:{ctx:K}}}),N=new Q({props:{title:"Improve performance",local:"improve-performance",headingTag:"h2"}}),A=new nt({props:{source:"https://github.com/huggingface/datasets/blob/main/docs/source/cache.mdx"}}),{c(){d=i("meta"),_=l(),g=i("p"),V=l(),c(w.$$.fragment),ee=l(),y=i("p"),y.innerHTML=Ye,te=l(),b=i("p"),b.textContent=Fe,ae=l(),v=i("p"),v.innerHTML=Le,se=l(),T=i("p"),T.textContent=Xe,le=l(),C=i("ul"),C.innerHTML=De,ne=l(),c(M.$$.fragment),ie=l(),x=i("p"),x.innerHTML=Ue,oe=l(),c(k.$$.fragment),de=l(),Z=i("p"),Z.innerHTML=We,re=l(),c(J.$$.fragment),ce=l(),c(H.$$.fragment),pe=l(),j=i("p"),j.innerHTML=Ee,he=l(),c(R.$$.fragment),me=l(),G=i("p"),G.innerHTML=Ie,fe=l(),c(Y.$$.fragment),ue=l(),F=i("p"),F.innerHTML=ze,ge=l(),c(L.$$.fragment),$e=l(),c(X.$$.fragment),_e=l(),D=i("p"),D.innerHTML=Ne,we=l(),c(U.$$.fragment),ye=l(),W=i("p"),W.innerHTML=Pe,be=l(),E=i("p"),E.innerHTML=Se,ve=l(),c(I.$$.fragment),Te=l(),z=i("p"),z.textContent=Ae,Ce=l(),c($.$$.fragment),Me=l(),B=i("a"),xe=l(),c(N.$$.fragment),ke=l(),P=i("p"),P.textContent=Ve,Ze=l(),S=i("ol"),S.innerHTML=Be,Je=l(),c(A.$$.fragment),He=l(),O=i("p"),this.h()},l(e){const t=at("svelte-u9bgzb",document.head);d=o(t,"META",{name:!0,content:!0}),t.forEach(a),_=n(e),g=o(e,"P",{}),Re(g).forEach(a),V=n(e),p(w.$$.fragment,e),ee=n(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-iay7o3"&&(y.innerHTML=Ye),te=n(e),b=o(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-19z69yp"&&(b.textContent=Fe),ae=n(e),v=o(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1o2qkzb"&&(v.innerHTML=Le),se=n(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-9v8z4"&&(T.textContent=Xe),le=n(e),C=o(e,"UL",{"data-svelte-h":!0}),r(C)!=="svelte-1pju6bx"&&(C.innerHTML=De),ne=n(e),p(M.$$.fragment,e),ie=n(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-n6ip78"&&(x.innerHTML=Ue),oe=n(e),p(k.$$.fragment,e),de=n(e),Z=o(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-rd1xw8"&&(Z.innerHTML=We),re=n(e),p(J.$$.fragment,e),ce=n(e),p(H.$$.fragment,e),pe=n(e),j=o(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-rzq8ij"&&(j.innerHTML=Ee),he=n(e),p(R.$$.fragment,e),me=n(e),G=o(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1tcg5ri"&&(G.innerHTML=Ie),fe=n(e),p(Y.$$.fragment,e),ue=n(e),F=o(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1qvf2q"&&(F.innerHTML=ze),ge=n(e),p(L.$$.fragment,e),$e=n(e),p(X.$$.fragment,e),_e=n(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-i94vid"&&(D.innerHTML=Ne),we=n(e),p(U.$$.fragment,e),ye=n(e),W=o(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-135z99u"&&(W.innerHTML=Pe),be=n(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-15v5bwk"&&(E.innerHTML=Se),ve=n(e),p(I.$$.fragment,e),Te=n(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1cf02ij"&&(z.textContent=Ae),Ce=n(e),p($.$$.fragment,e),Me=n(e),B=o(e,"A",{id:!0}),Re(B).forEach(a),xe=n(e),p(N.$$.fragment,e),ke=n(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1dk1qbe"&&(P.textContent=Ve),Ze=n(e),S=o(e,"OL",{"data-svelte-h":!0}),r(S)!=="svelte-1nkx5nz"&&(S.innerHTML=Be),Je=n(e),p(A.$$.fragment,e),He=n(e),O=o(e,"P",{}),Re(O).forEach(a),this.h()},h(){Ge(d,"name","hf:doc:metadata"),Ge(d,"content",dt),Ge(B,"id","load_dataset_enhancing_performance")},m(e,t){st(document.head,d),s(e,_,t),s(e,g,t),s(e,V,t),h(w,e,t),s(e,ee,t),s(e,y,t),s(e,te,t),s(e,b,t),s(e,ae,t),s(e,v,t),s(e,se,t),s(e,T,t),s(e,le,t),s(e,C,t),s(e,ne,t),h(M,e,t),s(e,ie,t),s(e,x,t),s(e,oe,t),h(k,e,t),s(e,de,t),s(e,Z,t),s(e,re,t),h(J,e,t),s(e,ce,t),h(H,e,t),s(e,pe,t),s(e,j,t),s(e,he,t),h(R,e,t),s(e,me,t),s(e,G,t),s(e,fe,t),h(Y,e,t),s(e,ue,t),s(e,F,t),s(e,ge,t),h(L,e,t),s(e,$e,t),h(X,e,t),s(e,_e,t),s(e,D,t),s(e,we,t),h(U,e,t),s(e,ye,t),s(e,W,t),s(e,be,t),s(e,E,t),s(e,ve,t),h(I,e,t),s(e,Te,t),s(e,z,t),s(e,Ce,t),h($,e,t),s(e,Me,t),s(e,B,t),s(e,xe,t),h(N,e,t),s(e,ke,t),s(e,P,t),s(e,Ze,t),s(e,S,t),s(e,Je,t),h(A,e,t),s(e,He,t),s(e,O,t),je=!0},p(e,[t]){const qe={};t&2&&(qe.$$scope={dirty:t,ctx:e}),$.$set(qe)},i(e){je||(m(w.$$.fragment,e),m(M.$$.fragment,e),m(k.$$.fragment,e),m(J.$$.fragment,e),m(H.$$.fragment,e),m(R.$$.fragment,e),m(Y.$$.fragment,e),m(L.$$.fragment,e),m(X.$$.fragment,e),m(U.$$.fragment,e),m(I.$$.fragment,e),m($.$$.fragment,e),m(N.$$.fragment,e),m(A.$$.fragment,e),je=!0)},o(e){f(w.$$.fragment,e),f(M.$$.fragment,e),f(k.$$.fragment,e),f(J.$$.fragment,e),f(H.$$.fragment,e),f(R.$$.fragment,e),f(Y.$$.fragment,e),f(L.$$.fragment,e),f(X.$$.fragment,e),f(U.$$.fragment,e),f(I.$$.fragment,e),f($.$$.fragment,e),f(N.$$.fragment,e),f(A.$$.fragment,e),je=!1},d(e){e&&(a(_),a(g),a(V),a(ee),a(y),a(te),a(b),a(ae),a(v),a(se),a(T),a(le),a(C),a(ne),a(ie),a(x),a(oe),a(de),a(Z),a(re),a(ce),a(pe),a(j),a(he),a(me),a(G),a(fe),a(ue),a(F),a(ge),a($e),a(_e),a(D),a(we),a(ye),a(W),a(be),a(E),a(ve),a(Te),a(z),a(Ce),a(Me),a(B),a(xe),a(ke),a(P),a(Ze),a(S),a(Je),a(He),a(O)),a(d),u(w,e),u(M,e),u(k,e),u(J,e),u(H,e),u(R,e),u(Y,e),u(L,e),u(X,e),u(U,e),u(I,e),u($,e),u(N,e),u(A,e)}}}const dt='{"title":"Cache management","local":"cache-management","sections":[{"title":"Cache directory","local":"cache-directory","sections":[],"depth":2},{"title":"Download mode","local":"download-mode","sections":[],"depth":2},{"title":"Cache files","local":"cache-files","sections":[],"depth":2},{"title":"Enable or disable caching","local":"enable-or-disable-caching","sections":[],"depth":2},{"title":"Improve performance","local":"improve-performance","sections":[],"depth":2}],"depth":1}';function rt(K){return Oe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends et{constructor(d){super(),tt(this,d,rt,ot,Qe,{})}}export{ut as component};
